// This file is generated by rust-protobuf 3.2.0. Do not edit
// .proto file is parsed by protoc --rust-out=...
// @generated

// https://github.com/rust-lang/rust-clippy/issues/702
#![allow(unknown_lints)]
#![allow(clippy::all)]

#![allow(unused_attributes)]
#![cfg_attr(rustfmt, rustfmt::skip)]

#![allow(box_pointers)]
#![allow(dead_code)]
#![allow(missing_docs)]
#![allow(non_camel_case_types)]
#![allow(non_snake_case)]
#![allow(non_upper_case_globals)]
#![allow(trivial_casts)]
#![allow(unused_results)]
#![allow(unused_mut)]

//! Generated file from `src/pb/ipns.proto`

/// Generated files are compatible only with the same version
/// of protobuf runtime.
const _PROTOBUF_VERSION_CHECK: () = ::protobuf::VERSION_3_2_0;

#[derive(PartialEq,Clone,Default,Debug)]
// @@protoc_insertion_point(message:ipns_proto.IpnsEntry)
pub struct IpnsEntry {
    // message fields
    ///  value to be stored in the record
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.value)
    pub value: ::std::option::Option<::std::vec::Vec<u8>>,
    ///  signature of the record
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.signature)
    pub signature: ::std::option::Option<::std::vec::Vec<u8>>,
    ///  Type of validation being used
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.validityType)
    pub validityType: ::std::option::Option<::protobuf::EnumOrUnknown<ipns_entry::ValidityType>>,
    ///  expiration datetime for the record in RFC3339 format
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.validity)
    pub validity: ::std::option::Option<::std::vec::Vec<u8>>,
    ///  number representing the version of the record
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.sequence)
    pub sequence: ::std::option::Option<u64>,
    ///  ttl in nanoseconds
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.ttl)
    pub ttl: ::std::option::Option<u64>,
    ///  in order for nodes to properly validate a record upon receipt, they need the public
    ///  key associated with it. For old RSA keys, its easiest if we just send this as part of
    ///  the record itself. For newer ed25519 keys, the public key can be embedded in the
    ///  peerID, making this field unnecessary.
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.pubKey)
    pub pubKey: ::std::option::Option<::std::vec::Vec<u8>>,
    ///  the v2 signature of the record
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.signatureV2)
    pub signatureV2: ::std::option::Option<::std::vec::Vec<u8>>,
    ///  extensible data
    // @@protoc_insertion_point(field:ipns_proto.IpnsEntry.data)
    pub data: ::std::option::Option<::std::vec::Vec<u8>>,
    // special fields
    // @@protoc_insertion_point(special_field:ipns_proto.IpnsEntry.special_fields)
    pub special_fields: ::protobuf::SpecialFields,
}

impl<'a> ::std::default::Default for &'a IpnsEntry {
    fn default() -> &'a IpnsEntry {
        <IpnsEntry as ::protobuf::Message>::default_instance()
    }
}

impl IpnsEntry {
    pub fn new() -> IpnsEntry {
        ::std::default::Default::default()
    }

    fn generated_message_descriptor_data() -> ::protobuf::reflect::GeneratedMessageDescriptorData {
        let mut fields = ::std::vec::Vec::with_capacity(9);
        let mut oneofs = ::std::vec::Vec::with_capacity(0);
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "value",
            |m: &IpnsEntry| { &m.value },
            |m: &mut IpnsEntry| { &mut m.value },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "signature",
            |m: &IpnsEntry| { &m.signature },
            |m: &mut IpnsEntry| { &mut m.signature },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "validityType",
            |m: &IpnsEntry| { &m.validityType },
            |m: &mut IpnsEntry| { &mut m.validityType },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "validity",
            |m: &IpnsEntry| { &m.validity },
            |m: &mut IpnsEntry| { &mut m.validity },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "sequence",
            |m: &IpnsEntry| { &m.sequence },
            |m: &mut IpnsEntry| { &mut m.sequence },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "ttl",
            |m: &IpnsEntry| { &m.ttl },
            |m: &mut IpnsEntry| { &mut m.ttl },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "pubKey",
            |m: &IpnsEntry| { &m.pubKey },
            |m: &mut IpnsEntry| { &mut m.pubKey },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "signatureV2",
            |m: &IpnsEntry| { &m.signatureV2 },
            |m: &mut IpnsEntry| { &mut m.signatureV2 },
        ));
        fields.push(::protobuf::reflect::rt::v2::make_option_accessor::<_, _>(
            "data",
            |m: &IpnsEntry| { &m.data },
            |m: &mut IpnsEntry| { &mut m.data },
        ));
        ::protobuf::reflect::GeneratedMessageDescriptorData::new_2::<IpnsEntry>(
            "IpnsEntry",
            fields,
            oneofs,
        )
    }
}

impl ::protobuf::Message for IpnsEntry {
    const NAME: &'static str = "IpnsEntry";

    fn is_initialized(&self) -> bool {
        true
    }

    fn merge_from(&mut self, is: &mut ::protobuf::CodedInputStream<'_>) -> ::protobuf::Result<()> {
        while let Some(tag) = is.read_raw_tag_or_eof()? {
            match tag {
                10 => {
                    self.value = ::std::option::Option::Some(is.read_bytes()?);
                },
                18 => {
                    self.signature = ::std::option::Option::Some(is.read_bytes()?);
                },
                24 => {
                    self.validityType = ::std::option::Option::Some(is.read_enum_or_unknown()?);
                },
                34 => {
                    self.validity = ::std::option::Option::Some(is.read_bytes()?);
                },
                40 => {
                    self.sequence = ::std::option::Option::Some(is.read_uint64()?);
                },
                48 => {
                    self.ttl = ::std::option::Option::Some(is.read_uint64()?);
                },
                58 => {
                    self.pubKey = ::std::option::Option::Some(is.read_bytes()?);
                },
                66 => {
                    self.signatureV2 = ::std::option::Option::Some(is.read_bytes()?);
                },
                74 => {
                    self.data = ::std::option::Option::Some(is.read_bytes()?);
                },
                tag => {
                    ::protobuf::rt::read_unknown_or_skip_group(tag, is, self.special_fields.mut_unknown_fields())?;
                },
            };
        }
        ::std::result::Result::Ok(())
    }

    // Compute sizes of nested messages
    #[allow(unused_variables)]
    fn compute_size(&self) -> u64 {
        let mut my_size = 0;
        if let Some(v) = self.value.as_ref() {
            my_size += ::protobuf::rt::bytes_size(1, &v);
        }
        if let Some(v) = self.signature.as_ref() {
            my_size += ::protobuf::rt::bytes_size(2, &v);
        }
        if let Some(v) = self.validityType {
            my_size += ::protobuf::rt::int32_size(3, v.value());
        }
        if let Some(v) = self.validity.as_ref() {
            my_size += ::protobuf::rt::bytes_size(4, &v);
        }
        if let Some(v) = self.sequence {
            my_size += ::protobuf::rt::uint64_size(5, v);
        }
        if let Some(v) = self.ttl {
            my_size += ::protobuf::rt::uint64_size(6, v);
        }
        if let Some(v) = self.pubKey.as_ref() {
            my_size += ::protobuf::rt::bytes_size(7, &v);
        }
        if let Some(v) = self.signatureV2.as_ref() {
            my_size += ::protobuf::rt::bytes_size(8, &v);
        }
        if let Some(v) = self.data.as_ref() {
            my_size += ::protobuf::rt::bytes_size(9, &v);
        }
        my_size += ::protobuf::rt::unknown_fields_size(self.special_fields.unknown_fields());
        self.special_fields.cached_size().set(my_size as u32);
        my_size
    }

    fn write_to_with_cached_sizes(&self, os: &mut ::protobuf::CodedOutputStream<'_>) -> ::protobuf::Result<()> {
        if let Some(v) = self.value.as_ref() {
            os.write_bytes(1, v)?;
        }
        if let Some(v) = self.signature.as_ref() {
            os.write_bytes(2, v)?;
        }
        if let Some(v) = self.validityType {
            os.write_enum(3, ::protobuf::EnumOrUnknown::value(&v))?;
        }
        if let Some(v) = self.validity.as_ref() {
            os.write_bytes(4, v)?;
        }
        if let Some(v) = self.sequence {
            os.write_uint64(5, v)?;
        }
        if let Some(v) = self.ttl {
            os.write_uint64(6, v)?;
        }
        if let Some(v) = self.pubKey.as_ref() {
            os.write_bytes(7, v)?;
        }
        if let Some(v) = self.signatureV2.as_ref() {
            os.write_bytes(8, v)?;
        }
        if let Some(v) = self.data.as_ref() {
            os.write_bytes(9, v)?;
        }
        os.write_unknown_fields(self.special_fields.unknown_fields())?;
        ::std::result::Result::Ok(())
    }

    fn special_fields(&self) -> &::protobuf::SpecialFields {
        &self.special_fields
    }

    fn mut_special_fields(&mut self) -> &mut ::protobuf::SpecialFields {
        &mut self.special_fields
    }

    fn new() -> IpnsEntry {
        IpnsEntry::new()
    }

    fn clear(&mut self) {
        self.value = ::std::option::Option::None;
        self.signature = ::std::option::Option::None;
        self.validityType = ::std::option::Option::None;
        self.validity = ::std::option::Option::None;
        self.sequence = ::std::option::Option::None;
        self.ttl = ::std::option::Option::None;
        self.pubKey = ::std::option::Option::None;
        self.signatureV2 = ::std::option::Option::None;
        self.data = ::std::option::Option::None;
        self.special_fields.clear();
    }

    fn default_instance() -> &'static IpnsEntry {
        static instance: IpnsEntry = IpnsEntry {
            value: ::std::option::Option::None,
            signature: ::std::option::Option::None,
            validityType: ::std::option::Option::None,
            validity: ::std::option::Option::None,
            sequence: ::std::option::Option::None,
            ttl: ::std::option::Option::None,
            pubKey: ::std::option::Option::None,
            signatureV2: ::std::option::Option::None,
            data: ::std::option::Option::None,
            special_fields: ::protobuf::SpecialFields::new(),
        };
        &instance
    }
}

impl ::protobuf::MessageFull for IpnsEntry {
    fn descriptor() -> ::protobuf::reflect::MessageDescriptor {
        static descriptor: ::protobuf::rt::Lazy<::protobuf::reflect::MessageDescriptor> = ::protobuf::rt::Lazy::new();
        descriptor.get(|| file_descriptor().message_by_package_relative_name("IpnsEntry").unwrap()).clone()
    }
}

impl ::std::fmt::Display for IpnsEntry {
    fn fmt(&self, f: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        ::protobuf::text_format::fmt(self, f)
    }
}

impl ::protobuf::reflect::ProtobufValue for IpnsEntry {
    type RuntimeType = ::protobuf::reflect::rt::RuntimeTypeMessage<Self>;
}

/// Nested message and enums of message `IpnsEntry`
pub mod ipns_entry {
    #[derive(Clone,Copy,PartialEq,Eq,Debug,Hash)]
    // @@protoc_insertion_point(enum:ipns_proto.IpnsEntry.ValidityType)
    pub enum ValidityType {
        // @@protoc_insertion_point(enum_value:ipns_proto.IpnsEntry.ValidityType.EOL)
        EOL = 0,
    }

    impl ::protobuf::Enum for ValidityType {
        const NAME: &'static str = "ValidityType";

        fn value(&self) -> i32 {
            *self as i32
        }

        fn from_i32(value: i32) -> ::std::option::Option<ValidityType> {
            match value {
                0 => ::std::option::Option::Some(ValidityType::EOL),
                _ => ::std::option::Option::None
            }
        }

        const VALUES: &'static [ValidityType] = &[
            ValidityType::EOL,
        ];
    }

    impl ::protobuf::EnumFull for ValidityType {
        fn enum_descriptor() -> ::protobuf::reflect::EnumDescriptor {
            static descriptor: ::protobuf::rt::Lazy<::protobuf::reflect::EnumDescriptor> = ::protobuf::rt::Lazy::new();
            descriptor.get(|| super::file_descriptor().enum_by_package_relative_name("IpnsEntry.ValidityType").unwrap()).clone()
        }

        fn descriptor(&self) -> ::protobuf::reflect::EnumValueDescriptor {
            let index = *self as usize;
            Self::enum_descriptor().value_by_index(index)
        }
    }

    impl ::std::default::Default for ValidityType {
        fn default() -> Self {
            ValidityType::EOL
        }
    }

    impl ValidityType {
        pub(in super) fn generated_enum_descriptor_data() -> ::protobuf::reflect::GeneratedEnumDescriptorData {
            ::protobuf::reflect::GeneratedEnumDescriptorData::new::<ValidityType>("IpnsEntry.ValidityType")
        }
    }
}

static file_descriptor_proto_data: &'static [u8] = b"\
    \n\x11src/pb/ipns.proto\x12\nipns_proto\"\xd4\x03\n\tIpnsEntry\x12\x19\n\
    \x05value\x18\x01\x20\x01(\x0cH\0R\x05value\x88\x01\x01\x12!\n\tsignatur\
    e\x18\x02\x20\x01(\x0cH\x01R\tsignature\x88\x01\x01\x12K\n\x0cvalidityTy\
    pe\x18\x03\x20\x01(\x0e2\".ipns_proto.IpnsEntry.ValidityTypeH\x02R\x0cva\
    lidityType\x88\x01\x01\x12\x1f\n\x08validity\x18\x04\x20\x01(\x0cH\x03R\
    \x08validity\x88\x01\x01\x12\x1f\n\x08sequence\x18\x05\x20\x01(\x04H\x04\
    R\x08sequence\x88\x01\x01\x12\x15\n\x03ttl\x18\x06\x20\x01(\x04H\x05R\
    \x03ttl\x88\x01\x01\x12\x1b\n\x06pubKey\x18\x07\x20\x01(\x0cH\x06R\x06pu\
    bKey\x88\x01\x01\x12%\n\x0bsignatureV2\x18\x08\x20\x01(\x0cH\x07R\x0bsig\
    natureV2\x88\x01\x01\x12\x17\n\x04data\x18\t\x20\x01(\x0cH\x08R\x04data\
    \x88\x01\x01\"\x17\n\x0cValidityType\x12\x07\n\x03EOL\x10\0B\x08\n\x06_v\
    alueB\x0c\n\n_signatureB\x0f\n\r_validityTypeB\x0b\n\t_validityB\x0b\n\t\
    _sequenceB\x06\n\x04_ttlB\t\n\x07_pubKeyB\x0e\n\x0c_signatureV2B\x07\n\
    \x05_dataJ\x9e\x0b\n\x06\x12\x04\x02\0(\x01\nE\n\x01\x0c\x12\x03\x02\0\
    \x122;\x20https://github.com/ipfs/go-ipns/blob/master/pb/ipns.proto\n\n\
    \x08\n\x01\x02\x12\x03\x04\0\x13\n\n\n\x02\x04\0\x12\x04\x06\0(\x01\n\n\
    \n\x03\x04\0\x01\x12\x03\x06\x08\x11\n\x0c\n\x04\x04\0\x04\0\x12\x04\x07\
    \x02\t\t\n\x0c\n\x05\x04\0\x04\0\x01\x12\x03\x07\x07\x13\nD\n\x06\x04\0\
    \x04\0\x02\0\x12\x03\x08\x10\x18\"5\x20setting\x20an\x20EOL\x20says\x20\
    \"this\x20record\x20is\x20valid\x20until...\"\n\n\x0e\n\x07\x04\0\x04\0\
    \x02\0\x01\x12\x03\x08\x10\x13\n\x0e\n\x07\x04\0\x04\0\x02\0\x02\x12\x03\
    \x08\x16\x17\n/\n\x04\x04\0\x02\0\x12\x03\x0c\x02\x1b\x1a\"\x20value\x20\
    to\x20be\x20stored\x20in\x20the\x20record\n\n\x0c\n\x05\x04\0\x02\0\x04\
    \x12\x03\x0c\x02\n\n\x0c\n\x05\x04\0\x02\0\x05\x12\x03\x0c\x0b\x10\n\x0c\
    \n\x05\x04\0\x02\0\x01\x12\x03\x0c\x11\x16\n\x0c\n\x05\x04\0\x02\0\x03\
    \x12\x03\x0c\x19\x1a\n&\n\x04\x04\0\x02\x01\x12\x03\x0f\x08%\x1a\x19\x20\
    signature\x20of\x20the\x20record\n\n\x0c\n\x05\x04\0\x02\x01\x04\x12\x03\
    \x0f\x08\x10\n\x0c\n\x05\x04\0\x02\x01\x05\x12\x03\x0f\x11\x16\n\x0c\n\
    \x05\x04\0\x02\x01\x01\x12\x03\x0f\x17\x20\n\x0c\n\x05\x04\0\x02\x01\x03\
    \x12\x03\x0f#$\n,\n\x04\x04\0\x02\x02\x12\x03\x12\x08/\x1a\x1f\x20Type\
    \x20of\x20validation\x20being\x20used\n\n\x0c\n\x05\x04\0\x02\x02\x04\
    \x12\x03\x12\x08\x10\n\x0c\n\x05\x04\0\x02\x02\x06\x12\x03\x12\x11\x1d\n\
    \x0c\n\x05\x04\0\x02\x02\x01\x12\x03\x12\x1e*\n\x0c\n\x05\x04\0\x02\x02\
    \x03\x12\x03\x12-.\nC\n\x04\x04\0\x02\x03\x12\x03\x15\x08$\x1a6\x20expir\
    ation\x20datetime\x20for\x20the\x20record\x20in\x20RFC3339\x20format\n\n\
    \x0c\n\x05\x04\0\x02\x03\x04\x12\x03\x15\x08\x10\n\x0c\n\x05\x04\0\x02\
    \x03\x05\x12\x03\x15\x11\x16\n\x0c\n\x05\x04\0\x02\x03\x01\x12\x03\x15\
    \x17\x1f\n\x0c\n\x05\x04\0\x02\x03\x03\x12\x03\x15\"#\n<\n\x04\x04\0\x02\
    \x04\x12\x03\x18\x08%\x1a/\x20number\x20representing\x20the\x20version\
    \x20of\x20the\x20record\n\n\x0c\n\x05\x04\0\x02\x04\x04\x12\x03\x18\x08\
    \x10\n\x0c\n\x05\x04\0\x02\x04\x05\x12\x03\x18\x11\x17\n\x0c\n\x05\x04\0\
    \x02\x04\x01\x12\x03\x18\x18\x20\n\x0c\n\x05\x04\0\x02\x04\x03\x12\x03\
    \x18#$\n!\n\x04\x04\0\x02\x05\x12\x03\x1b\x08\x20\x1a\x14\x20ttl\x20in\
    \x20nanoseconds\n\n\x0c\n\x05\x04\0\x02\x05\x04\x12\x03\x1b\x08\x10\n\
    \x0c\n\x05\x04\0\x02\x05\x05\x12\x03\x1b\x11\x17\n\x0c\n\x05\x04\0\x02\
    \x05\x01\x12\x03\x1b\x18\x1b\n\x0c\n\x05\x04\0\x02\x05\x03\x12\x03\x1b\
    \x1e\x1f\n\xb4\x02\n\x04\x04\0\x02\x06\x12\x03!\x08\"\x1a\xa6\x02\x20in\
    \x20order\x20for\x20nodes\x20to\x20properly\x20validate\x20a\x20record\
    \x20upon\x20receipt,\x20they\x20need\x20the\x20public\n\x20key\x20associ\
    ated\x20with\x20it.\x20For\x20old\x20RSA\x20keys,\x20its\x20easiest\x20i\
    f\x20we\x20just\x20send\x20this\x20as\x20part\x20of\n\x20the\x20record\
    \x20itself.\x20For\x20newer\x20ed25519\x20keys,\x20the\x20public\x20key\
    \x20can\x20be\x20embedded\x20in\x20the\n\x20peerID,\x20making\x20this\
    \x20field\x20unnecessary.\n\n\x0c\n\x05\x04\0\x02\x06\x04\x12\x03!\x08\
    \x10\n\x0c\n\x05\x04\0\x02\x06\x05\x12\x03!\x11\x16\n\x0c\n\x05\x04\0\
    \x02\x06\x01\x12\x03!\x17\x1d\n\x0c\n\x05\x04\0\x02\x06\x03\x12\x03!\x20\
    !\n-\n\x04\x04\0\x02\x07\x12\x03$\x08'\x1a\x20\x20the\x20v2\x20signature\
    \x20of\x20the\x20record\n\n\x0c\n\x05\x04\0\x02\x07\x04\x12\x03$\x08\x10\
    \n\x0c\n\x05\x04\0\x02\x07\x05\x12\x03$\x11\x16\n\x0c\n\x05\x04\0\x02\
    \x07\x01\x12\x03$\x17\"\n\x0c\n\x05\x04\0\x02\x07\x03\x12\x03$%&\n\x1e\n\
    \x04\x04\0\x02\x08\x12\x03'\x08\x20\x1a\x11\x20extensible\x20data\n\n\
    \x0c\n\x05\x04\0\x02\x08\x04\x12\x03'\x08\x10\n\x0c\n\x05\x04\0\x02\x08\
    \x05\x12\x03'\x11\x16\n\x0c\n\x05\x04\0\x02\x08\x01\x12\x03'\x17\x1b\n\
    \x0c\n\x05\x04\0\x02\x08\x03\x12\x03'\x1e\x1fb\x06proto3\
";

/// `FileDescriptorProto` object which was a source for this generated file
fn file_descriptor_proto() -> &'static ::protobuf::descriptor::FileDescriptorProto {
    static file_descriptor_proto_lazy: ::protobuf::rt::Lazy<::protobuf::descriptor::FileDescriptorProto> = ::protobuf::rt::Lazy::new();
    file_descriptor_proto_lazy.get(|| {
        ::protobuf::Message::parse_from_bytes(file_descriptor_proto_data).unwrap()
    })
}

/// `FileDescriptor` object which allows dynamic access to files
pub fn file_descriptor() -> &'static ::protobuf::reflect::FileDescriptor {
    static generated_file_descriptor_lazy: ::protobuf::rt::Lazy<::protobuf::reflect::GeneratedFileDescriptor> = ::protobuf::rt::Lazy::new();
    static file_descriptor: ::protobuf::rt::Lazy<::protobuf::reflect::FileDescriptor> = ::protobuf::rt::Lazy::new();
    file_descriptor.get(|| {
        let generated_file_descriptor = generated_file_descriptor_lazy.get(|| {
            let mut deps = ::std::vec::Vec::with_capacity(0);
            let mut messages = ::std::vec::Vec::with_capacity(1);
            messages.push(IpnsEntry::generated_message_descriptor_data());
            let mut enums = ::std::vec::Vec::with_capacity(1);
            enums.push(ipns_entry::ValidityType::generated_enum_descriptor_data());
            ::protobuf::reflect::GeneratedFileDescriptor::new_generated(
                file_descriptor_proto(),
                deps,
                messages,
                enums,
            )
        });
        ::protobuf::reflect::FileDescriptor::new_generated_2(generated_file_descriptor)
    })
}
